import React from 'react';
import { IVariable, IVariableContainer } from '@brudererdev/web-extensions';
import { ServiceVariableInjectorProps, VariableRenderingProps } from './../../shared/variableProps';
interface ILocalProps {
    container?: IVariableContainer;
    containerDisplayKeyFilter?: string;
    renderType?: 'container' | 'variables';
    onWriteVariables?: (changedVariables: Array<IVariable>) => void;
    onCustomVariableRendering?: (renderingProps: VariableRenderingProps) => React.ReactElement<VariableRenderingProps> | undefined;
    onCustomListRendering?: (container: IVariableContainer, index: number, isOpen: boolean) => React.ReactElement | undefined | boolean;
    onCustomListHeaderRendering?: (container: IVariableContainer, index: number, isOpen: boolean) => React.ReactElement | undefined;
    onAdditionalListContentRendering?: (container: IVariableContainer, index: number, isOpen: boolean) => React.ReactElement | undefined;
}
declare type Props = ILocalProps & ServiceVariableInjectorProps;
export declare const ServiceVariableContainerInjector: React.FC<Props>;
export {};
