import React from 'react';
import { IVariableContainer } from '@brudererdev/web-extensions';
import { VariableRenderingProps, VariableContainerProps } from './../../shared/variableProps';
interface ILocalProps {
    containers: IVariableContainer | IVariableContainer[] | undefined;
    renderType?: 'container' | 'variables';
    containerDisplayKeyFilter?: string;
    filter?: string;
    minimumFilterLength?: number;
    onCustomVariableRendering?: (renderingProps: VariableRenderingProps) => React.ReactElement<VariableRenderingProps> | undefined;
    onCustomListRendering?: (container: IVariableContainer, index: number, isOpen: boolean) => React.ReactElement | undefined | boolean;
    onCustomListHeaderRendering?: (container: IVariableContainer, index: number, isOpen: boolean) => React.ReactElement | undefined;
    onAdditionalListContentRendering?: (container: IVariableContainer, index: number, isOpen: boolean) => React.ReactElement | undefined;
}
declare type Props = ILocalProps & VariableContainerProps;
export declare const VariableContainerRenderer: React.FC<Props>;
export {};
