import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { Box, Menu, MenuItem, Typography } from '@mui/material';
export const SelectableMenu = (props) => {
    const renderElementIcon = (IconElement) => {
        if (!IconElement)
            return (_jsx("div", { style: { width: 36 } }, void 0));
        if (typeof IconElement === 'string')
            return (_jsx("span", { style: {
                    width: 36,
                    fontSize: 24
                }, children: IconElement }, void 0));
        return (_jsx(IconElement, { style: { width: 36 } }, void 0));
    };
    const getMenuSelectedStyle = () => {
        var menuSelectedStyle = props.menuSelectedStyle;
        if (!menuSelectedStyle)
            menuSelectedStyle = {
                backgroundColor: (theme) => theme.palette.secondary.main,
                color: (theme) => theme.palette.secondary.contrastText,
                fill: (theme) => theme.palette.secondary.contrastText,
            };
        return menuSelectedStyle;
    };
    if (!props.elements)
        return null;
    return (_jsx(Menu, { anchorEl: props.anchor, open: Boolean(props.anchor), onClose: props.onClose, children: props.elements
            .filter((element) => element.isVisible === undefined || element.isVisible)
            .map((element, index) => {
            var elementIndex = props.elements.indexOf(element);
            var isSelectedElement = (props.selectedElementIndex !== undefined) ? (props.selectedElementIndex === elementIndex) : false;
            return (_jsxs(MenuItem, { sx: {
                    '&.MuiMenuItem-root': (theme) => ({
                        backgroundColor: theme.palette.menu.main,
                        color: theme.palette.menu.contrastText,
                        fill: theme.palette.menu.contrastText,
                        ':hover': {
                            backgroundColor: theme.palette.grey[700],
                            color: theme.palette.menu.contrastText,
                            fill: theme.palette.menu.contrastText
                        }
                    }),
                    '&.Mui-selected': (theme) => ({
                        ...getMenuSelectedStyle()
                    })
                }, selected: isSelectedElement, onClick: (e) => props.onSelect(e, element, elementIndex), children: [renderElementIcon(element.icon), _jsx(Box, { sx: { minWidth: 8 } }, void 0), _jsx(Typography, { variant: 'h5', children: (props.onLocalize !== undefined) ? props.onLocalize(element.display) : element.display.value }, void 0)] }, elementIndex));
        }) }, void 0));
};
