import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { Box } from '@mui/material';
import { SizeInjectorContainer } from './containers/SizeInjectorContainer';
export const View = (props) => {
    // Helpers
    const showHeader = (props.showHeader !== undefined) ? props.showHeader : false;
    const showFooter = (props.showFooter !== undefined) ? props.showFooter : false;
    const contentMargin = (props.contentMargin !== undefined) ? props.contentMargin : 0;
    return (_jsxs(Box, { sx: {
            display: 'flex',
            flexDirection: 'column',
            height: '100%',
            backgroundColor: (theme) => theme.palette.view.main,
            color: (theme) => theme.palette.view.contrastText,
            fill: (theme) => theme.palette.view.contrastText
        }, children: [showHeader && props.onRenderHeader &&
                props.onRenderHeader(), _jsx(Box, { sx: {
                    overflow: 'hidden',
                    flex: 'auto',
                    margin: contentMargin
                }, children: _jsx(SizeInjectorContainer, { containerStyle: props.contentStyle, isScrollLocked: props.isScrollLocked, children: props.children }, void 0) }, void 0), showFooter && props.onRenderFooter &&
                props.onRenderFooter()] }, void 0));
};
