import { jsx as _jsx } from "react/jsx-runtime";
import { Box } from '@mui/material';
import { SizeEnumeration } from './../../shared/styleProps';
export const getInfoBadgeSizeValue = (size) => {
    var sizeValue = 24;
    switch (size) {
        case SizeEnumeration.xs:
            sizeValue = 16;
            break;
        case SizeEnumeration.s:
            sizeValue = 20;
            break;
        case SizeEnumeration.m:
            sizeValue = 24;
            break;
        case SizeEnumeration.l:
            sizeValue = 28;
            break;
        case SizeEnumeration.xl:
            sizeValue = 32;
            break;
        default:
            sizeValue = 24;
            break;
    }
    return sizeValue;
};
export const InfoBadge = (props) => {
    return (_jsx(Box, { sx: {
            position: 'relative',
            zIndex: 1
        }, children: _jsx(Box, { component: 'span', boxShadow: 3, sx: [
                {
                    position: 'absolute',
                    top: (props.topOffset ? props.topOffset : 0) - (props.contenMargin ? props.contenMargin : 0),
                    left: (props.leftOffset ? props.leftOffset : 0) - (props.contenMargin ? props.contenMargin : 0),
                    padding: props.contenMargin ? props.contenMargin : 0,
                    height: getInfoBadgeSizeValue(props.size),
                    width: getInfoBadgeSizeValue(props.size),
                    borderRadius: (getInfoBadgeSizeValue(props.size) / 2) + (props.contenMargin ? props.contenMargin : 0),
                    display: 'flex',
                    flexDirection: 'column',
                    alignContent: 'center',
                    alignItems: 'center',
                    justifyContent: 'center',
                    justifyItems: 'center',
                    textAlign: 'center',
                    backgroundColor: (theme) => theme.palette.primary.main,
                    color: (theme) => theme.palette.primary.contrastText,
                    fill: (theme) => theme.palette.primary.contrastText,
                },
                (theme) => ({
                    ...props.badgeStyle
                })
            ], onClick: props.onClick, children: props.children }, void 0) }, void 0));
};
