import { jsx as _jsx } from "react/jsx-runtime";
import { Box } from '@mui/material';
import { SizeEnumeration } from './../../shared/styleProps';
export const getAppBarSizeValue = (size) => {
    var sizeValue = 64;
    switch (size) {
        case SizeEnumeration.xs:
            sizeValue = 32;
            break;
        case SizeEnumeration.s:
            sizeValue = 64;
            break;
        case SizeEnumeration.m:
            sizeValue = 96;
            break;
        case SizeEnumeration.l:
            sizeValue = 128;
            break;
        case SizeEnumeration.xl:
            sizeValue = 256;
            break;
        default:
            sizeValue = 64;
            break;
    }
    return sizeValue;
};
export const AppBar = (props) => {
    return (_jsx(Box, { boxShadow: 3, sx: {
            position: 'relative',
            zIndex: 5,
            width: '100%',
            height: getAppBarSizeValue(props.size)
        }, children: props.children }, void 0));
};
