import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import React from 'react';
import { Box } from '@mui/material';
import { horizontalLineStyle } from './../../styles/themeExtensions';
import { WrapContainer } from './../containers/WrapContainer';
import { Tile } from './../elements/Tile';
export const CommandBar = (props) => {
    // Helpers
    const showDivider = props.showDivider !== undefined ? props.showDivider : true;
    const dividerPosition = props.dividerPosition !== undefined ? props.dividerPosition : 'bottom';
    const rtl = props.rtl !== undefined ? props.rtl : true;
    return (_jsxs(Box, { sx: {
            width: '100%',
            height: 'auto',
            alignSelf: 'flex-end'
        }, children: [showDivider && (dividerPosition === 'bottom') &&
                _jsxs(React.Fragment, { children: [_jsx(Box, { minHeight: 8 }, void 0), _jsx(Box, { component: 'hr', sx: { ...horizontalLineStyle } }, void 0)] }, void 0), _jsx(WrapContainer, { margin: 1, reverse: rtl, children: props.commandTiles.map((tile, index) => {
                    const isVisibile = (tile.isVisible !== undefined) ? tile.isVisible : true;
                    if (!isVisibile)
                        return;
                    const height = tile.height ? tile.height : 56;
                    const width = tile.width ? tile.width : 'auto';
                    return (_jsx(Box, { children: _jsx(Tile, { ...tile, height: height, width: width, onClick: (e) => {
                                if (tile.onClick)
                                    tile.onClick(e);
                                if (tile.onCommandClick)
                                    tile.onCommandClick(e, index);
                            }, children: tile.content }, void 0) }, index));
                }) }, void 0), showDivider && (dividerPosition === 'top') &&
                _jsxs(React.Fragment, { children: [_jsx(Box, { component: 'hr', sx: { ...horizontalLineStyle } }, void 0), _jsx(Box, { minHeight: 8 }, void 0)] }, void 0)] }, void 0));
};
