import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import React from 'react';
import { Box } from '@mui/material';
;
const progressStyle = {
    backgroundColor: (theme) => theme.palette.secondary.main,
    color: (theme) => theme.palette.secondary.contrastText,
    fill: (theme) => theme.palette.secondary.contrastText
};
const progressNegativeStyle = {
    backgroundColor: (theme) => theme.palette.error.main,
    color: (theme) => theme.palette.error.contrastText,
    fill: (theme) => theme.palette.error.contrastText
};
export const ProgressBar = (props) => {
    const getFillerWidth = (origin, progress) => {
        const widthPercentage = (progress > origin) ? progress - origin : origin - progress;
        if (orientation === 'horizontal') {
            return widthPercentage;
        }
        else
            return 100;
    };
    const getFillerHeight = (origin, progress) => {
        const heightPercentage = (progress > origin) ? progress - origin : origin - progress;
        if (orientation === 'horizontal') {
            return 100;
        }
        else
            return heightPercentage;
    };
    const getFillerTopOffset = (origin, progress) => {
        if (orientation === 'vertical')
            if (isInverted)
                return (progress > origin) ? 100 - progress : 100 - origin;
            else
                return (progress > origin) ? origin : progress;
        else {
            return 0;
        }
    };
    const getFillerLeftOffset = (origin, progress) => {
        if (orientation === 'horizontal')
            if (isInverted)
                return (progress > origin) ? 100 - progress : 100 - origin;
            else
                return (progress > origin) ? origin : progress;
        else {
            return 0;
        }
    };
    const getFillerStyle = () => {
        if (originPercentage > progressPercentage)
            return props.fillerStyle ? props.fillerStyle : progressNegativeStyle;
        return props.fillerStyle ? props.fillerStyle : progressStyle;
    };
    const getMarkTopOffset = (progress) => {
        if (isInverted) {
            if (orientation === 'vertical')
                return 100 - progress;
            else
                return 0;
        }
        else {
            if (orientation === 'vertical')
                return progress;
            else
                return 0;
        }
    };
    const getMarkLeftOffset = (progress) => {
        if (isInverted) {
            if (orientation === 'horizontal')
                return progress;
            else
                return 0;
        }
        else {
            if (orientation === 'horizontal')
                return 100 - progress;
            else
                return 0;
        }
    };
    const renderMarks = () => {
        var marks = [];
        // Add origin mark
        const originMark = {
            value: originValue,
            label: _jsxs(React.Fragment, { children: [_jsx(Box, { sx: {
                            height: 2,
                            width: 16,
                            backgroundColor: (theme) => theme.palette.primary.main,
                            color: (theme) => theme.palette.primary.contrastText,
                            fill: (theme) => theme.palette.primary.contrastText
                        } }, void 0), _jsx(Box, { sx: {
                            position: 'absolute',
                            left: 20,
                            top: -16
                        } }, void 0)] }, void 0)
        };
        if (props.minValue < originValue && props.maxValue > originValue && !hideDefaultMark)
            marks.push(originMark);
        if (props.marks)
            marks = marks.concat(marks, props.marks);
        if (!marks)
            return null;
        return (_jsx(React.Fragment, { children: marks.map((progressMark, index) => {
                var markPositionPercentage = (progressMark.value - props.minValue) * 100 / (props.maxValue - props.minValue);
                if (!markPositionPercentage)
                    markPositionPercentage = 0;
                return (_jsx(Box, { component: 'span', position: 'absolute', top: `${getMarkTopOffset(markPositionPercentage)}%`, right: `${getMarkLeftOffset(markPositionPercentage)}%`, children: progressMark.label }, index));
            }) }, void 0));
    };
    // Helpers
    const size = props.size ? props.size : 8;
    const orientation = props.orientation ? props.orientation : 'horizontal';
    const isInverted = props.isInverted ? props.isInverted : false;
    const originValue = props.originValue ? props.originValue : 0;
    const hideDefaultMark = props.hideDefaultMark ? props.hideDefaultMark : false;
    // Setup origin percentage
    var originPercentage = (originValue - props.minValue) * 100 / (props.maxValue - props.minValue);
    if (originPercentage < 0 || !originPercentage)
        originPercentage = 0;
    if (originPercentage > 100)
        originPercentage = 100;
    // Setup progress percentage
    var progressPercentage = (props.value - props.minValue) * 100 / (props.maxValue - props.minValue);
    if (progressPercentage < 0 || !progressPercentage)
        progressPercentage = 0;
    if (progressPercentage > 100)
        progressPercentage = 100;
    return (_jsxs(Box, { sx: {
            position: 'relative',
            display: 'flex',
            flexDirection: 'column',
            width: (orientation === 'horizontal') ? '100%' : undefined,
            height: (orientation === 'vertical') ? '100%' : undefined
        }, children: [_jsx(Box, { sx: {
                    position: 'relative',
                    flex: 'auto',
                    height: (orientation === 'horizontal') ? size : undefined,
                    width: (orientation === 'vertical') ? size : undefined,
                    backgroundColor: (theme) => theme.palette.background.default,
                    color: (theme) => theme.palette.getContrastText(theme.palette.background.default),
                    fill: (theme) => theme.palette.getContrastText(theme.palette.background.default)
                }, children: _jsx(Box, { component: 'span', sx: {
                        position: 'absolute',
                        top: `${getFillerTopOffset(originPercentage, progressPercentage)}%`,
                        left: `${getFillerLeftOffset(originPercentage, progressPercentage)}%`,
                        height: `${getFillerHeight(originPercentage, progressPercentage)}%`,
                        width: `${getFillerWidth(originPercentage, progressPercentage)}%`,
                        ...getFillerStyle()
                    } }, void 0) }, void 0), renderMarks(), _jsx(Box, { sx: {
                    position: 'absolute',
                    top: `${getMarkTopOffset(progressPercentage)}%`,
                    right: `${getMarkLeftOffset(progressPercentage)}%`
                }, children: _jsx(Box, { sx: {
                        position: 'relative'
                    }, children: props.onRenderProgressContent && props.onRenderProgressContent(props.value, progressPercentage) }, void 0) }, void 0)] }, void 0));
};
