import React from 'react';
import { LocalizeMethod, BrudererUserRoleEnumeration } from '@brudererdev/web-extensions';
import { INavigationElement } from '../..';
interface ILocalProps {
    headerText?: string;
    rtl?: boolean;
    elements?: Array<INavigationElement>;
    defaultNavigationElement: INavigationElement;
    selectedElementIndex?: number;
    isMessageBarVisible?: boolean;
    isSearchVisible?: boolean;
    hasActionTiles?: boolean;
    userRoles?: Array<BrudererUserRoleEnumeration>;
    locale?: string;
    onLocalize?: LocalizeMethod;
    onSelectTile?: (element: INavigationElement) => boolean;
    onShowSearchFilter?: (e: React.MouseEvent<HTMLElement>) => void;
    onShowApps?: (e: React.MouseEvent<HTMLElement>) => void;
    onShowActionTiles?: (e: React.MouseEvent<HTMLElement>) => void;
    onClose?: (e: React.MouseEvent<HTMLElement>) => void;
    onSearch?: (input: string) => void;
    onSearchTextChanged?: (input: string) => void;
    onAssistantClick?: () => void;
    onStatusClick?: () => void;
    onMessageAcknowledge?: () => void;
}
declare type Props = ILocalProps;
export declare const ViewTopBar: React.FC<Props>;
export {};
