import { jsx as _jsx } from "react/jsx-runtime";
import { Box } from '@mui/material';
import { SizeEnumeration } from './../../shared/styleProps';
export const getElementContainerSizeValue = (size) => {
    const defaultSizeValue = 80;
    const defaultSpaceValue = 2 * 4;
    var sizeValue = defaultSizeValue;
    switch (size) {
        case SizeEnumeration.xs:
            sizeValue = 80;
            break;
        case SizeEnumeration.s:
            sizeValue = (2 * defaultSizeValue) + (1 * defaultSpaceValue);
            break;
        case SizeEnumeration.m:
            sizeValue = (3 * defaultSizeValue) + (2 * defaultSpaceValue);
            break;
        case SizeEnumeration.l:
            sizeValue = (4 * defaultSizeValue) + (3 * defaultSpaceValue);
            break;
        case SizeEnumeration.xl:
            sizeValue = (6 * defaultSizeValue) + (5 * defaultSpaceValue);
            break;
        case SizeEnumeration.undefined:
            sizeValue = undefined;
            break;
        default:
            sizeValue = (2 * defaultSizeValue) + (1 * defaultSpaceValue);
            break;
    }
    return sizeValue;
};
export const ElementContainer = (props) => {
    return (_jsx(Box, { sx: {
            display: 'flex',
            flexDirection: 'column',
            justifyItems: 'flex-start',
            justifyContent: 'flex-start',
            width: getElementContainerSizeValue(props.size ? props.size : SizeEnumeration.s)
        }, children: props.children }, void 0));
};
