import { jsx as _jsx } from "react/jsx-runtime";
import { Box } from '@mui/material';
import { scrollHorizontalStyle, scrollVerticalStyle } from './../../styles/themeExtensions';
export const ScrollContainer = (props) => {
    // Helpers
    const margin = props.margin !== undefined ? props.margin : 0;
    const orientation = props.orientation !== undefined ? props.orientation : 'horizontal';
    const getScrollStyle = () => {
        if (orientation === 'horizontal')
            return scrollHorizontalStyle;
        return scrollVerticalStyle;
    };
    return (_jsx(Box, { sx: {
            ...getScrollStyle(),
            marginTop: margin
        }, className: props.className, children: _jsx(Box, { sx: {
                display: 'flex',
                flexDirection: (orientation === 'horizontal') ? 'row' : 'column'
            }, children: props.children }, void 0) }, void 0));
};
