import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { useState, useRef, useEffect } from 'react';
import { Box } from '@mui/material';
;
export const CirclePosition = (props) => {
    // States
    const [height, setHeight] = useState(0);
    const [width, setWidth] = useState(0);
    // Refs
    const containerRef = useRef(null);
    // Effects
    useEffect(() => {
        if (containerRef.current !== null)
            if (containerRef.current.offsetHeight !== height)
                setHeight(containerRef.current.offsetHeight);
        if (containerRef.current !== null)
            if (containerRef.current.offsetWidth !== width)
                setWidth(containerRef.current.offsetWidth);
    });
    const getMaxSize = () => {
        // get maximum circle size
        var maxSize = width < height ? width : height;
        if (maxSize <= 0)
            maxSize = 64;
        return maxSize;
    };
    const getIndicatorSize = () => {
        var indicatorSize = borderWidth * 2;
        return indicatorSize;
    };
    const getSize = () => {
        // Get actual circle size
        var size = maxSize;
        if (props.size && props.size <= maxSize)
            size = props.size;
        if (props.customContentsOutside)
            size -= radiusOffset * 2;
        else
            size -= (indicatorSize / 2);
        return size;
    };
    const getAngle = (angle) => {
        // Rotation direction CW or CCW?
        if (!props.rotationCCW)
            return angle;
        return (angle * -1);
    };
    const getCustomContentsRotateRadius = (contentOffset) => {
        if (props.customContentsOutside)
            return rotateRadius + borderWidth / 2 + contentOffset;
        return rotateRadius - borderWidth / 2 - contentOffset;
    };
    // Helpers
    const borderWidth = props.borderWidth ? props.borderWidth : 12;
    const showIndicatorPosition = props.showIndicatorPosition ? props.showIndicatorPosition : true;
    const showCustomPositionContents = props.showCustomPositionContents ? props.showCustomPositionContents : false;
    const renderCustomPositionContents = props.renderCustomPositionContents ? props.renderCustomPositionContents : [];
    var maxSize = getMaxSize();
    const indicatorSize = getIndicatorSize();
    const radiusOffset = props.radiusOffset ? props.radiusOffset : 0;
    const size = getSize();
    const rotateRadius = (size / 2) - (borderWidth / 2);
    const angle = getAngle(props.angle);
    var customContentAngle = 0;
    return (_jsxs(Box, { ref: containerRef, sx: {
            position: 'relative',
            height: '100%',
            width: '100%',
            display: 'flex',
            flexDirection: 'column',
            alignItems: 'center',
            alignContent: 'center',
            justifyItems: 'center',
            justifyContent: 'center'
        }, children: [showCustomPositionContents && renderCustomPositionContents.map((customContent, index) => {
                customContentAngle = getAngle(customContent.angle);
                return (_jsx(Box // Custom circle content
                , { sx: {
                        zIndex: 3,
                        position: 'absolute',
                        transform: `rotate(${customContentAngle + 180}deg) translate(${0}px, ${getCustomContentsRotateRadius(customContent.contentRadiusOffset ? customContent.contentRadiusOffset : 0)}px) rotate(${customContent.followRotation ? 180 : -customContentAngle + 180}deg)`,
                        filter: 'blur(0)'
                    }, children: customContent.renderContent(customContent.angle) }, index));
            }), _jsxs(Box // Circle
            , { sx: {
                    position: 'relative',
                    display: 'flex',
                    flexDirection: 'column',
                    alignItems: 'center',
                    alignContent: 'center',
                    justifyItems: 'center',
                    justifyContent: 'center',
                    borderRadius: '50%',
                    borderStyle: 'solid',
                    color: (theme) => theme.palette.background.default,
                    fill: (theme) => theme.palette.primary.main,
                    height: size,
                    width: size,
                    borderWidth: borderWidth
                }, children: [showIndicatorPosition &&
                        _jsx(Box // Indicator
                        , { sx: {
                                position: 'absolute',
                                borderRadius: '50%',
                                backgroundColor: (theme) => theme.palette.secondary.main,
                                color: (theme) => theme.palette.secondary.contrastText,
                                fill: (theme) => theme.palette.secondary.contrastText,
                                zIndex: 4,
                                height: indicatorSize,
                                width: indicatorSize,
                                transform: `rotate(${angle + 180}deg) translate(${0}px, ${rotateRadius}px)`
                            } }, void 0), props.renderCustomCenterContent && props.renderCustomCenterContent() /* Custom center content */] }, void 0)] }, void 0));
};
