import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import React from 'react';
import { LocalizationNamespaces } from '@brudererdev/web-extensions';
import { FormControl, InputLabel, Select, FilledInput, FormHelperText, MenuItem, Box, Typography } from '@mui/material';
export const ColorSelector = (props) => {
    const handleSelectorChange = (e, child) => {
        var targetValue = e.target.value;
        // Invoke changed method
        if (props.onSelectionChanged)
            props.onSelectionChanged(targetValue);
    };
    const isValidColor = (color) => {
        const s = new Option().style;
        s.color = color;
        return s.color !== '';
    };
    // Helpers
    const showInitialValueOnChange = (props.showInitialValueOnChange !== undefined) ? props.showInitialValueOnChange : false;
    const isPreselectedColorValid = isValidColor(props.preselectedColor);
    const areColorsValid = props.colors.every(color => isValidColor(color));
    var selectedValue = props.preselectedColor;
    var noValidDataText = 'No vaild data';
    if (props.onLocalize)
        noValidDataText = props.onLocalize({
            link: {
                key: 'global.novaliddata',
                path: 'global',
                name: 'novaliddata',
                seperator: '.'
            },
            keyNamespace: LocalizationNamespaces.UIGeneric,
            value: 'No vaild data'
        });
    if (!isPreselectedColorValid ||
        !areColorsValid)
        selectedValue = noValidDataText;
    return (_jsx(React.Fragment, { children: _jsxs(FormControl, { variant: 'filled', margin: 'dense', disabled: props.isDisabled, sx: {
                width: '100%',
                height: '100%'
            }, children: [_jsx(InputLabel, { color: 'secondary', disabled: props.isDisabled, children: _jsx(Box, { sx: {
                            display: 'flex',
                            flexDirection: 'row',
                            alignContent: 'center',
                            alignItems: 'center'
                        } }, void 0) }, void 0), _jsxs(Select, { labelId: "label", value: selectedValue, disabled: props.isDisabled, onChange: handleSelectorChange, input: _jsx(FilledInput, { autoComplete: 'off', autoCorrect: 'off', autoCapitalize: 'off', disabled: props.isDisabled, sx: {
                            '& .MuiInputBase-input': {
                                fontSize: '2.35rem',
                                paddingTop: '23px',
                                paddingBottom: 0,
                                caretColor: (theme) => theme.palette.secondary.main
                            }
                        } }, void 0), children: [props.colors.map((color, index) => {
                            if (!areColorsValid)
                                return undefined;
                            return (_jsx(MenuItem, { value: color, sx: {
                                    '&.MuiMenuItem-root': {
                                        backgroundColor: (theme) => theme.palette.menu.main,
                                        color: (theme) => theme.palette.menu.contrastText,
                                        fill: (theme) => theme.palette.menu.contrastText,
                                        ':hover': {
                                            backgroundColor: (theme) => theme.palette.grey[700],
                                            color: (theme) => theme.palette.menu.contrastText,
                                            fill: (theme) => theme.palette.menu.contrastText
                                        }
                                    },
                                    '&.Mui-selected': {
                                        backgroundColor: (theme) => theme.palette.secondary.main,
                                        color: (theme) => theme.palette.secondary.contrastText,
                                        fill: (theme) => theme.palette.secondary.contrastText
                                    }
                                }, children: _jsx(Box, { sx: {
                                        height: 24,
                                        width: '100%',
                                        backgroundColor: color
                                    } }, void 0) }, index));
                        }), (!isPreselectedColorValid || !areColorsValid) &&
                            _jsx(MenuItem, { value: '', children: _jsx(Typography, { variant: 'h5', children: noValidDataText }, void 0) }, void 0)] }, void 0), _jsx(FormHelperText, { disabled: props.isDisabled, sx: (theme) => ({
                        '&.MuiFormHelperText-root': {
                            opacity: 1.0,
                            overflowWrap: 'anywhere',
                            fontWeight: 'normal',
                            ...theme.typography.body1
                        }
                    }), children: props.localizedLabelText }, void 0)] }, void 0) }, void 0));
};
