import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import React, { useState, useRef, useEffect } from 'react';
import { ColorEnumeration } from './../../shared/styleProps';
export const Divider = (props) => {
    // States
    const [height, setHeight] = useState(0);
    const [width, setWidth] = useState(0);
    // Refs
    const containerRef = useRef(null);
    // Effects
    useEffect(() => {
        if (containerRef.current !== null)
            if (containerRef.current.offsetHeight !== height)
                setHeight(containerRef.current.offsetHeight);
        if (containerRef.current !== null)
            if (containerRef.current.offsetWidth !== width)
                setWidth(containerRef.current.offsetWidth);
    });
    // Helpers
    const color = props.color ? props.color : ColorEnumeration.primary;
    const thickness = (props.thickness !== undefined) ? props.thickness : 2;
    return (_jsxs("div", Object.assign({ ref: containerRef, className: 'divider-root text-no-wrap' }, { children: [props.children &&
                _jsxs(React.Fragment, { children: [_jsx("hr", { className: `color-${color.valueOf()}`, style: {
                                width: 16,
                                border: 'none',
                                borderTopWidth: thickness,
                                borderTopStyle: 'solid',
                                margin: 0
                            } }, void 0), _jsx("div", { style: {
                                height: height,
                                width: 4
                            } }, void 0), _jsx("div", Object.assign({ className: `divider-content ${color.valueOf()}` }, { children: props.children }), void 0), _jsx("div", { style: {
                                height: height,
                                width: 4
                            } }, void 0)] }, void 0), _jsx("hr", { className: `color-${color.valueOf()}`, style: {
                    width: '100%',
                    border: 'none',
                    borderTopWidth: thickness,
                    borderTopStyle: 'solid',
                    margin: 0
                } }, void 0)] }), void 0));
};
