import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import React, { useState, useRef, useEffect } from 'react';
import { Box, Typography, } from '@mui/material';
import { textBreakWordStyle } from './../../styles/themeExtensions';
export const Label = (props) => {
    // States
    const [height, setHeight] = useState(0);
    const [width, setWidth] = useState(0);
    // Refs
    const containerRef = useRef(null);
    // Effects
    useEffect(() => {
        if (containerRef.current !== null)
            if (containerRef.current.offsetHeight !== height)
                setHeight(containerRef.current.offsetHeight);
        if (containerRef.current !== null)
            if (containerRef.current.offsetWidth !== width)
                setWidth(containerRef.current.offsetWidth);
    });
    const getAdornmentStyle = () => {
        if (!isStartAdornmentVisible)
            return undefined;
        var adornmentStyle = props.adornmentStyle;
        if (!adornmentStyle)
            adornmentStyle = {
                backgroundColor: (theme) => theme.palette.primary.main,
                color: (theme) => theme.palette.primary.contrastText,
                fill: (theme) => theme.palette.primary.contrastText
            };
        return adornmentStyle;
    };
    // Helpers
    const selectedWidth = props.width !== undefined ? props.width : '100%';
    const topOffset = props.topOffset !== undefined ? props.topOffset : 8;
    const bottomOffset = props.bottomOffset !== undefined ? props.bottomOffset : 8;
    const isStartAdornmentVisible = props.isStartAdornmentVisible !== undefined ? props.isStartAdornmentVisible : true;
    const hasStartAdornmentIndent = props.hasStartAdornmentIndent !== undefined ? props.hasStartAdornmentIndent : true;
    const textVariant = (props.variant !== undefined) ? props.variant : 'h5';
    return (_jsxs(React.Fragment, { children: [_jsx(Box, { sx: {
                    height: topOffset,
                    minHeight: topOffset
                } }, void 0), _jsxs(Box, { ref: containerRef, sx: {
                    display: 'flex',
                    flexDirection: 'row',
                    width: selectedWidth
                }, children: [(isStartAdornmentVisible || hasStartAdornmentIndent) &&
                        _jsxs(React.Fragment, { children: [_jsx(Box, { sx: {
                                        height: height,
                                        minWidth: 4,
                                        ...getAdornmentStyle()
                                    } }, void 0), _jsx(Box, { sx: {
                                        minWidth: 8
                                    } }, void 0)] }, void 0), _jsx(Box, { sx: {
                            flex: 'auto'
                        }, children: _jsx(Typography, { sx: (theme) => ({
                                ...textBreakWordStyle,
                                ...props.typographyStyle
                            }), align: props.align, variant: textVariant, children: props.children }, void 0) }, void 0)] }, void 0), _jsx(Box, { sx: {
                    height: bottomOffset,
                    width: bottomOffset
                } }, void 0)] }, void 0));
};
