import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { Box, Typography, } from '@mui/material';
import { textBreakWordStyle } from './../../styles/themeExtensions';
import { Tile } from './Tile';
export const LabelTile = (props) => {
    // Props assertions
    var tileProps = props;
    // Helpers
    const hideLabel = (props.hideLabel !== undefined) ? props.hideLabel : false;
    const textVariant = (props.textVariant !== undefined) ? props.textVariant : 'h6';
    const textAlign = (props.textAlign !== undefined) ? props.textAlign : 'center';
    if (hideLabel)
        return (_jsx(Tile, { ...tileProps, children: props.children }, void 0));
    return (_jsxs(Box, { sx: {
            display: 'flex',
            flexDirection: 'column',
            alignItems: 'center',
            alignContent: 'center'
        }, children: [_jsx(Tile, { ...tileProps, children: props.children }, void 0), _jsx(Box, { sx: { minHeight: (theme) => theme.spacing(1) } }, void 0), _jsx(Typography, { sx: (theme) => ({
                    ...textBreakWordStyle,
                    ...props.typographyStyle
                }), align: textAlign, variant: textVariant, children: props.text }, void 0), _jsx(Box, { sx: { minHeight: (theme) => theme.spacing(2) } }, void 0)] }, void 0));
};
