import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import React from 'react';
import { LocalizationNamespaces } from '@brudererdev/web-extensions';
import { FormControl, InputLabel, Select, FilledInput, FormHelperText, MenuItem, Box, Typography } from '@mui/material';
export const Selector = (props) => {
    const handleSelectorChange = (e, child) => {
        var targetValue = e.target.value;
        // Invoke changed method
        if (props.onSelectionChanged)
            props.onSelectionChanged(targetValue);
    };
    // Helpers
    const showInitialValueOnChange = (props.showInitialValueOnChange !== undefined) ? props.showInitialValueOnChange : false;
    var selectedValue = {
        display: {
            link: {
                key: 'global.novaliddata',
                path: 'global',
                name: 'novaliddata',
                seperator: '.'
            },
            keyNamespace: LocalizationNamespaces.UIGeneric,
            value: 'No vaild data'
        },
        key: 'undefined',
        value: ''
    };
    var noValidDataText = 'No vaild data';
    if (props.onLocalize)
        noValidDataText = props.onLocalize({
            link: {
                key: 'global.novaliddata',
                path: 'global',
                name: 'novaliddata',
                seperator: '.'
            },
            keyNamespace: LocalizationNamespaces.UIGeneric,
            value: 'No vaild data'
        });
    const selectedMapValue = props.selectionMap.values.find((map, index) => {
        if (props.onSelection)
            return props.onSelection(props.preselectedValue, map.value, index);
        if (typeof props.preselectedValue === 'boolean' && typeof map.value === 'boolean')
            return props.preselectedValue === map.value;
        if (typeof props.preselectedValue === 'number' && typeof map.value === 'number')
            return props.preselectedValue === map.value;
        if (typeof props.preselectedValue === 'string' && typeof map.value === 'string')
            return props.preselectedValue === map.value;
        return false;
    });
    if (selectedMapValue)
        selectedValue = selectedMapValue;
    return (_jsx(React.Fragment, { children: _jsxs(FormControl, { variant: 'filled', margin: 'dense', disabled: props.isDisabled, sx: {
                width: '100%',
                height: '100%'
            }, children: [_jsx(InputLabel, { color: 'secondary', disabled: props.isDisabled, children: _jsx(Box, { sx: {
                            display: 'flex',
                            flexDirection: 'row',
                            alignContent: 'center',
                            alignItems: 'center'
                        } }, void 0) }, void 0), _jsxs(Select, { labelId: "label", value: selectedValue.value, disabled: props.isDisabled, onChange: handleSelectorChange, input: _jsx(FilledInput, { autoComplete: 'off', autoCorrect: 'off', autoCapitalize: 'off', disabled: props.isDisabled, sx: {
                            '& .MuiInputBase-input': {
                                fontSize: '2.35rem',
                                paddingTop: '23px',
                                paddingBottom: 0,
                                caretColor: (theme) => theme.palette.secondary.main
                            }
                        } }, void 0), children: [props.selectionMap &&
                            props.selectionMap.values.map((selectionValueMap, index) => {
                                return (_jsx(MenuItem, { value: selectionValueMap.value, sx: {
                                        '&.MuiMenuItem-root': {
                                            backgroundColor: (theme) => theme.palette.menu.main,
                                            color: (theme) => theme.palette.menu.contrastText,
                                            fill: (theme) => theme.palette.menu.contrastText,
                                            ':hover': {
                                                backgroundColor: (theme) => theme.palette.grey[700],
                                                color: (theme) => theme.palette.menu.contrastText,
                                                fill: (theme) => theme.palette.menu.contrastText
                                            }
                                        },
                                        '&.Mui-selected': {
                                            backgroundColor: (theme) => theme.palette.secondary.main,
                                            color: (theme) => theme.palette.secondary.contrastText,
                                            fill: (theme) => theme.palette.secondary.contrastText
                                        }
                                    }, children: _jsx(Typography, { variant: 'h5', children: (props.onLocalize !== undefined) ? props.onLocalize(selectionValueMap.display) : selectionValueMap.display.value }, void 0) }, index));
                            }), !props.selectionMap &&
                            _jsx(MenuItem, { value: '', children: _jsx(Typography, { variant: 'h5', children: noValidDataText }, void 0) }, void 0)] }, void 0), _jsxs(FormHelperText, { disabled: props.isDisabled, sx: (theme) => ({
                        '&.MuiFormHelperText-root': {
                            opacity: 1.0,
                            overflowWrap: 'anywhere',
                            fontWeight: 'normal',
                            ...theme.typography.body1
                        }
                    }), children: [props.localizedLabelText && props.localizedLabelText, !props.localizedLabelText && ((props.onLocalize !== undefined) ? props.onLocalize(props.selectionMap.display) : props.selectionMap.display.value)] }, void 0)] }, void 0) }, void 0));
};
