/** @jsxImportSource @emotion/react */
import React from 'react';
import { Theme } from '@mui/material/styles';
import { SxProps } from '@mui/system';
import { ViewProps } from '../..';
export declare enum ElementStatusEnumeration {
    Inactive = 0,
    Active = 1,
    Warning = 2,
    Info = 3,
    Error = 4
}
export interface ICustomStatusIcons {
    inactiveIcon: React.FunctionComponent<any> | React.ComponentType<any> | string;
    activeIcon: React.FunctionComponent<any> | React.ComponentType<any> | string;
    warningIcon: React.FunctionComponent<any> | React.ComponentType<any> | string;
    infoIcon: React.FunctionComponent<any> | React.ComponentType<any> | string;
    errorIcon: React.FunctionComponent<any> | React.ComponentType<any> | string;
}
export interface ICustomStatusStyles {
    inactiveStyle: SxProps<Theme>;
    activeStyle: SxProps<Theme>;
    warningStyle: SxProps<Theme>;
    infoStyle: SxProps<Theme>;
    errorStyle: SxProps<Theme>;
    flshingStyle: SxProps<Theme>;
}
interface ILocalProps {
    status?: ElementStatusEnumeration;
    iconSize?: number;
    isFlashing?: boolean;
    flashingInterval?: number;
    customStatusIcons?: ICustomStatusIcons;
    customStatusStyles?: ICustomStatusStyles;
    onRenderCustomStatus?: (status: ElementStatusEnumeration) => React.ReactElement;
}
declare type Props = ILocalProps & ViewProps;
export declare const StatusIcon: React.FC<Props>;
export {};
