import React from 'react';
import { LocalizeMethod } from '@brudererdev/web-extensions';
interface ILocalProps {
    values: Array<string>;
    /**
     * Preselected value after mounting.
     */
    preselectedIndex?: number;
    /**
    * Force selected index else it will be set automatically.
    */
    selectedIndex?: number;
    localizedLabelText: string;
    isDisabled?: boolean;
    showInitialValueOnChange?: boolean;
    onLocalize?: LocalizeMethod;
    /**
     * Callback fired when a menu item is selected.
     */
    onSelectionChanged?: (selectedIndex: number, lastIndex: number) => void;
    /**
     * Callback fired to check selection before item will be selected.
     */
    checkSelection?: (selectedIndex: number) => boolean;
    onSelection?: (preselectedValue: any, mapValue: any, index: number) => boolean;
}
declare type Props = ILocalProps;
export declare const StringSelector: React.FC<Props>;
export {};
