import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import React, { useState } from 'react';
import { LocalizationNamespaces } from '@brudererdev/web-extensions';
import { FormControl, InputLabel, Select, FilledInput, FormHelperText, MenuItem, Box, Typography } from '@mui/material';
export const StringSelector = (props) => {
    const [selecedItemIndex, setSelectedItemIndex] = useState(props.preselectedIndex !== undefined ? props.preselectedIndex : -1);
    const handleSelectorChange = (e, child) => {
        var targetValue = e.target.value;
        if (props.checkSelection)
            if (props.checkSelection(targetValue)) {
                if (props.onSelectionChanged)
                    if (props.selectedIndex)
                        props.onSelectionChanged(targetValue, props.selectedIndex);
                    else
                        props.onSelectionChanged(targetValue, selecedItemIndex);
                setSelectedItemIndex(targetValue);
            }
    };
    // Helpers
    const showInitialValueOnChange = (props.showInitialValueOnChange !== undefined) ? props.showInitialValueOnChange : false;
    const selectedItemIndex = props.selectedIndex !== undefined ? props.selectedIndex : selecedItemIndex;
    var noValidDataText = 'No vaild data';
    if (props.onLocalize)
        noValidDataText = props.onLocalize({
            link: {
                key: 'global.novaliddata',
                path: 'global',
                name: 'novaliddata',
                seperator: '.'
            },
            keyNamespace: LocalizationNamespaces.UIGeneric,
            value: 'No vaild data'
        });
    return (_jsx(React.Fragment, { children: _jsxs(FormControl, { variant: 'filled', margin: 'dense', disabled: props.isDisabled, sx: {
                width: '100%',
                height: '100%'
            }, children: [_jsx(InputLabel, { color: 'secondary', disabled: props.isDisabled, children: _jsx(Box, { sx: {
                            display: 'flex',
                            flexDirection: 'row',
                            alignContent: 'center',
                            alignItems: 'center'
                        } }, void 0) }, void 0), _jsxs(Select, { labelId: "label", value: selectedItemIndex, disabled: props.isDisabled, onChange: handleSelectorChange, sx: {
                        '& .MuiSelect-filled': {
                            paddingBottom: '2px',
                            paddingTop: '23px'
                        },
                        '& .MuiSelect-nativeInput': {},
                        '& .MuiSelect-icon': {},
                        '& .MuiSelect-select': {
                            ":focus": {
                                backgroundColor: (theme) => theme.palette.card.main
                            }
                        }
                    }, input: _jsx(FilledInput, { autoComplete: 'off', autoCorrect: 'off', autoCapitalize: 'off', disabled: props.isDisabled, sx: {
                            '& .MuiInputBase-input': {
                                fontSize: '2.35rem',
                                paddingTop: '23px',
                                paddingBottom: 0,
                                caretColor: (theme) => theme.palette.secondary.main
                            }
                        } }, void 0), children: [props.values.length > 0 &&
                            props.values.map((value, index) => {
                                return (_jsx(MenuItem, { value: index, sx: {
                                        '&.MuiMenuItem-root': {
                                            backgroundColor: (theme) => theme.palette.menu.main,
                                            color: (theme) => theme.palette.menu.contrastText,
                                            fill: (theme) => theme.palette.menu.contrastText,
                                            ':hover': {
                                                backgroundColor: (theme) => theme.palette.grey[700],
                                                color: (theme) => theme.palette.menu.contrastText,
                                                fill: (theme) => theme.palette.menu.contrastText
                                            }
                                        },
                                        '&.Mui-selected': {
                                            backgroundColor: (theme) => theme.palette.secondary.main,
                                            color: (theme) => theme.palette.secondary.contrastText,
                                            fill: (theme) => theme.palette.secondary.contrastText
                                        }
                                    }, children: _jsx(Typography, { variant: 'h5', children: value }, void 0) }, index));
                            }), props.values.length == 0 &&
                            _jsx(MenuItem, { value: -1, children: _jsx(Typography, { variant: 'h5', children: noValidDataText }, void 0) }, void 0)] }, void 0), _jsx(FormHelperText, { disabled: props.isDisabled, sx: (theme) => ({
                        '&.MuiFormHelperText-root': {
                            opacity: 1.0,
                            overflowWrap: 'anywhere',
                            fontWeight: 'normal',
                            ...theme.typography.body1
                        }
                    }), children: props.localizedLabelText }, void 0)] }, void 0) }, void 0));
};
