import { jsx as _jsx } from "react/jsx-runtime";
import { ColorSelector } from './ColorSelector';
;
;
export const VarColorSelector = (props) => {
    // Fields
    const contextName = 'VarColorSelector';
    const handleSelectionChanged = (selectedColor) => {
        if (isReadOnly)
            return;
        var varClone = { ...props.modelVariable };
        varClone.value = selectedColor;
        // Invoke changed method
        if (props.onModelVariableChanged)
            props.onModelVariableChanged(varClone);
    };
    // Check preselected value
    var preselectedColor = '';
    if (props.modelVariable.value !== null && props.modelVariable.value !== undefined)
        preselectedColor = props.modelVariable.value;
    if (props.newValue !== null && props.newValue !== undefined)
        preselectedColor = props.newValue;
    // Get localized display text
    var displayText = props.modelVariable.display.value;
    if (props.onLocalize)
        displayText = props.onLocalize(props.modelVariable.display);
    // Helpers
    const isReadOnlyForced = (props.forceReadOnly !== undefined) ? props.forceReadOnly : false;
    const isReadOnly = isReadOnlyForced ? isReadOnlyForced : props.modelVariable.isReadOnly;
    return (_jsx(ColorSelector, { colors: props.colors, preselectedColor: preselectedColor, localizedLabelText: displayText, isDisabled: props.isDisabled || isReadOnly, onLocalize: props.onLocalize, onSelectionChanged: handleSelectionChanged }, void 0));
};
