import { jsx as _jsx, jsxs as _jsxs } from "@emotion/react/jsx-runtime";
import { TypeValidatorNET } from '@brudererdev/web-extensions';
import { Box, Typography } from '@mui/material';
import CheckIcon from '@mui/icons-material/Check';
import ClearIcon from '@mui/icons-material/Clear';
import InfoOutlinedIcon from '@mui/icons-material/InfoOutlined';
export const VarStatus = (props) => {
    const getCondition = () => {
        if (props.condition)
            return props.condition;
        // Check value for null or undefined
        var conditionValue = false;
        if (TypeValidatorNET.isBoolean(props.modelVariable.valueType)) {
            if (props.modelVariable.value !== null && props.modelVariable.value !== undefined)
                conditionValue = props.modelVariable.value;
            // if (props.newValue !== null && props.newValue !== undefined)
            //   switchValue = props.newValue;
        }
        return conditionValue;
    };
    const getStateIcon = () => {
        if (props.stateIcon)
            return props.stateIcon;
        const condition = getCondition();
        if (condition)
            return CheckIcon;
        else
            return ClearIcon;
    };
    const getStateStyle = () => {
        if (props.stateStyle)
            return props.stateStyle;
        const condition = getCondition();
        if (condition)
            return {
                //backgroundColor: (theme) => theme.palette.grey[600],
                color: (theme) => theme.palette.success.main,
                fill: (theme) => theme.palette.success.main
            };
        else
            return {
                //backgroundColor: (theme) => theme.palette.grey[600],
                color: (theme) => theme.palette.error.main,
                fill: (theme) => theme.palette.error.main
            };
    };
    const renderStartAdornmentIcon = () => {
        var IconElement = props.StartAdornmentIcon;
        if (IconElement == undefined)
            IconElement = InfoOutlinedIcon;
        if (!IconElement)
            return;
        const iconSize = 24;
        const fontSize = (iconSize * 24) / 32;
        if (typeof IconElement === 'string')
            return (_jsx(Box, { component: 'span', sx: {
                    fontSize: fontSize
                }, children: IconElement }, void 0));
        return (_jsx(IconElement, { css: {
                minWidth: iconSize,
                minHeight: iconSize,
                width: iconSize,
                height: iconSize
            } }, void 0));
    };
    const renderStartAdornment = () => {
        if (!props.showStartAdornment)
            return undefined;
        return (_jsx(Box, { sx: {
                marginLeft: 1,
                marginRight: 1,
                display: 'flex',
                flexDirection: 'column',
                justifyContent: 'flex-end',
                justifyItems: 'flex-end'
            }, children: renderStartAdornmentIcon() }, void 0));
    };
    const renderEndAdornment = () => {
        if (!props.showStartAdornment)
            return undefined;
        return (_jsx(Box, { sx: {
                width: 24,
                marginLeft: 1,
                marginRight: 1
            } }, void 0));
    };
    var displayText = props.modelVariable.display.value;
    if (props.onLocalize)
        displayText = props.onLocalize(props.modelVariable.display);
    // Helpers
    const StateIcon = getStateIcon();
    return (_jsxs(Box, { sx: {
            display: 'flex',
            flexDirection: 'column'
        }, children: [_jsxs(Box, { sx: {
                    marginTop: '16px',
                    marginBottom: '8px',
                    maxHeight: 40,
                    width: '100%',
                    alignSelf: 'center',
                    display: 'flex',
                    flexDirection: 'row'
                }, children: [renderStartAdornment(), _jsxs(Box, { sx: {
                            marginLeft: 'auto',
                            marginRight: 'auto'
                        }, children: [props.onRenderCustomState && props.onRenderCustomState(), !props.onRenderCustomState &&
                                _jsx(Box, { sx: {
                                        display: 'flex',
                                        alignItems: 'center',
                                        alignContent: 'center',
                                        justifyItems: 'center',
                                        justifyContent: 'center',
                                        borderRadius: '50%',
                                        ...getStateStyle()
                                    }, children: _jsx(StateIcon, { sx: {
                                            minHeight: 40,
                                            height: 40,
                                            minWidth: 40,
                                            width: 40
                                        } }, void 0) }, void 0)] }, void 0), renderEndAdornment()] }, void 0), _jsx(Box, { component: 'hr', sx: {
                    width: '100%',
                    margin: 0,
                    border: 'none',
                    borderTop: props.isDisabled ? '1px dotted' : '1px solid'
                } }, void 0), _jsx(Box, { sx: {
                    display: 'flex',
                    flexDirection: 'column',
                    marginTop: '4px',
                    marginLeft: '12px',
                    marginRight: '12px',
                    overflowWrap: 'anywhere'
                }, children: _jsx(Typography, { variant: 'body1', children: displayText }, void 0) }, void 0)] }, void 0));
};
