import { jsx as _jsx, jsxs as _jsxs } from "@emotion/react/jsx-runtime";
import { TypeValidatorNET } from '@brudererdev/web-extensions';
import { Box, Switch, Typography } from '@mui/material';
import InfoOutlinedIcon from '@mui/icons-material/InfoOutlined';
export const VarSwitch = (props) => {
    const handleSwitchChange = (e) => {
        if (isReadOnly)
            return;
        var varClone = { ...props.modelVariable };
        varClone.value = e.target.checked;
        // Invoke changed method
        if (props.onModelVariableChanged)
            props.onModelVariableChanged(varClone);
    };
    // Check value for null or undefined
    var switchValue = false;
    if (TypeValidatorNET.isBoolean(props.modelVariable.valueType)) {
        if (props.modelVariable.value !== null && props.modelVariable.value !== undefined)
            switchValue = props.modelVariable.value;
        if (props.newValue !== null && props.newValue !== undefined)
            switchValue = props.newValue;
    }
    // Get localized display text
    var displayText = props.modelVariable.display.value;
    if (props.onLocalize)
        displayText = props.onLocalize(props.modelVariable.display);
    // Helpers
    const isReadOnlyForced = (props.forceReadOnly !== undefined) ? props.forceReadOnly : false;
    const isReadOnly = isReadOnlyForced ? isReadOnlyForced : props.modelVariable.isReadOnly;
    const renderStartAdornmentIcon = () => {
        var IconElement = props.StartAdornmentIcon;
        if (IconElement == undefined)
            IconElement = InfoOutlinedIcon;
        if (!IconElement)
            return;
        const iconSize = 24;
        const fontSize = (iconSize * 24) / 32;
        if (typeof IconElement === 'string')
            return (_jsx(Box, { component: 'span', sx: {
                    fontSize: fontSize
                }, children: IconElement }, void 0));
        return (_jsx(IconElement, { css: {
                minWidth: iconSize,
                minHeight: iconSize,
                width: iconSize,
                height: iconSize
            } }, void 0));
    };
    const renderStartAdornment = () => {
        if (!props.showStartAdornment)
            return undefined;
        return (_jsx(Box, { sx: {
                marginLeft: 1,
                marginRight: 1,
                display: 'flex',
                flexDirection: 'column',
                justifyContent: 'flex-end',
                justifyItems: 'flex-end'
            }, children: renderStartAdornmentIcon() }, void 0));
    };
    const renderEndAdornment = () => {
        if (!props.showStartAdornment)
            return undefined;
        return (_jsx(Box, { sx: {
                width: 24,
                marginLeft: 1,
                marginRight: 1
            } }, void 0));
    };
    return (_jsxs(Box, { sx: {
            display: 'flex',
            flexDirection: 'column'
        }, children: [_jsxs(Box, { sx: {
                    marginTop: '16px',
                    marginBottom: '6px',
                    display: 'flex',
                    flexDirection: 'row'
                }, children: [renderStartAdornment(), _jsx(Box, { sx: {
                            marginLeft: 'auto',
                            marginRight: 'auto'
                        }, children: _jsx(Switch, { color: 'success', sx: {
                                '&.MuiSwitch-root': {
                                    width: 72,
                                    height: 42
                                },
                                '& .MuiSwitch-switchBase': {
                                    '&.Mui-checked': {
                                        transform: 'translateX(28px)'
                                    },
                                    '&.Mui-disabled': {
                                        opacity: 0.6
                                    }
                                },
                                '& .MuiSwitch-thumb': {
                                    width: 24,
                                    height: 24
                                },
                                '& .MuiSwitch-track': {
                                    borderRadius: 21
                                }
                            }, checked: switchValue, disabled: props.isDisabled || isReadOnly, onChange: handleSwitchChange }, void 0) }, void 0), renderEndAdornment()] }, void 0), _jsx(Box, { component: 'hr', sx: {
                    width: '100%',
                    margin: 0,
                    border: 'none',
                    borderTop: props.isDisabled ? '1px dotted' : '1px solid'
                } }, void 0), _jsx(Box, { sx: {
                    display: 'flex',
                    flexDirection: 'column',
                    marginTop: '4px',
                    marginLeft: '12px',
                    marginRight: '12px',
                    overflowWrap: 'anywhere'
                }, children: _jsx(Typography, { variant: 'body1', children: displayText }, void 0) }, void 0)] }, void 0));
};
