import { jsx as _jsx, jsxs as _jsxs } from "@emotion/react/jsx-runtime";
/* eslint-disable react/react-in-jsx-scope -- Unaware of jsxImportSource */
/** @jsxImportSource @emotion/react */
import { useState } from 'react';
import { TypeValidatorNET, SelectionMaps } from '@brudererdev/web-extensions';
import { Box, Typography } from '@mui/material';
import InfoOutlinedIcon from '@mui/icons-material/InfoOutlined';
export const VarTextOut = (props) => {
    // States
    const [selectionMap, setSelectionMap] = useState(SelectionMaps.find(map => map.key === props.modelVariable.valueEnumerationKey));
    const locale = (props.locale !== undefined) ? props.locale : 'de-DE';
    var displayText = props.modelVariable.display.value;
    if (props.onLocalize)
        displayText = props.onLocalize(props.modelVariable.display);
    const getValueText = () => {
        var valueText = '';
        if (!props.modelVariable.valueEnumerationKey)
            valueText = TypeValidatorNET.formatValue(props.modelVariable.value, props.modelVariable.valueType, locale, props.modelVariable.valuePrecision);
        else if (selectionMap !== undefined) { //if it is a read-only enumeration value, get enumeration value an localise it
            var initialValueMap = selectionMap.values.find((map, index) => map.value === props.modelVariable.value);
            if (initialValueMap !== undefined && initialValueMap !== null) {
                valueText = initialValueMap.display.value;
                if (props.onLocalize)
                    valueText = props.onLocalize(initialValueMap.display);
            }
        }
        return valueText;
    };
    const renderStartAdornmentIcon = () => {
        var IconElement = props.StartAdornmentIcon;
        if (IconElement == undefined)
            IconElement = InfoOutlinedIcon;
        if (!IconElement)
            return;
        const iconSize = 24;
        const fontSize = (iconSize * 24) / 32;
        if (typeof IconElement === 'string')
            return (_jsx(Box, { component: 'span', sx: {
                    fontSize: fontSize
                }, children: IconElement }, void 0));
        return (_jsx(IconElement, { css: {
                minWidth: iconSize,
                minHeight: iconSize,
                width: iconSize,
                height: iconSize
            } }, void 0));
    };
    const renderStartAdornment = () => {
        if (!props.showStartAdornment)
            return undefined;
        return (_jsx(Box, { sx: {
                height: '100%',
                marginRight: 1,
                display: 'flex',
                flexDirection: 'column',
                justifyContent: 'center',
                justifyItems: 'center'
            }, children: renderStartAdornmentIcon() }, void 0));
    };
    const renderEndAdornment = () => {
        return (_jsx(Box, { sx: {
                marginTop: '8px',
                marginLeft: 'auto',
                marginRight: '4px'
            }, children: _jsx(Typography, { variant: 'body1', children: props.modelVariable.engineeringUnit ? props.modelVariable.engineeringUnit.displayName : '' }, void 0) }, void 0));
    };
    return (_jsxs(Box, { sx: {
            height: '100%',
            width: '100%',
            display: 'flex',
            flexDirection: 'column',
            marginTop: '8px',
            marginBottom: '4px',
            opacity: props.isDisabled ? .6 : 1.0
        }, children: [_jsx(Box, { sx: {
                    display: 'flex',
                    flexDirection: 'column',
                    marginTop: '24px',
                    marginBottom: '0px',
                    marginLeft: '12px',
                    marginRight: '8px'
                }, children: _jsxs(Box, { sx: {
                        display: 'flex',
                        flexDirection: 'row',
                        width: '100%'
                    }, children: [renderStartAdornment(), _jsx(Typography, { sx: {
                                minHeight: '32px'
                            }, variant: 'h5', children: getValueText() }, void 0), renderEndAdornment()] }, void 0) }, void 0), _jsx(Box, { component: 'hr', sx: {
                    width: '100%',
                    margin: 0,
                    border: 'none',
                    borderTop: props.isDisabled ? '1px dotted' : '1px solid'
                } }, void 0), _jsx(Box, { sx: {
                    display: 'flex',
                    flexDirection: 'column',
                    marginTop: '4px',
                    marginLeft: '12px',
                    marginRight: '12px',
                    overflowWrap: 'anywhere'
                }, children: _jsx(Typography, { variant: 'body1', children: displayText }, void 0) }, void 0)] }, void 0));
};
