import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { useTheme } from '@mui/material/styles';
import { SizeEnumeration } from './../../shared/styleProps';
export const Indicator1 = (props) => {
    // External hooks
    const themeStyles = useTheme();
    const getIndicatorSizeValue = (size) => {
        var sizeValue = 24;
        switch (size) {
            case SizeEnumeration.xs:
                sizeValue = 8;
                break;
            case SizeEnumeration.s:
                sizeValue = 16;
                break;
            case SizeEnumeration.m:
                sizeValue = 24;
                break;
            case SizeEnumeration.l:
                sizeValue = 32;
                break;
            case SizeEnumeration.xl:
                sizeValue = 64;
                break;
            default:
                sizeValue = 24;
                break;
        }
        return sizeValue;
    };
    // Helpers
    const backgroundColor = (props.backgroundColor !== undefined) ? props.backgroundColor : themeStyles.palette.secondary.main;
    const color = (props.color !== undefined) ? props.color : themeStyles.palette.secondary.contrastText;
    return (_jsx("div", { className: 'indicator-container', children: _jsxs("div", { className: "indicator1-spinner", children: [_jsx("div", { className: 'indicator1-spinner-bounce1', style: {
                        backgroundColor: backgroundColor,
                        color: color,
                        fill: color,
                        height: getIndicatorSizeValue(props.size),
                        width: getIndicatorSizeValue(props.size)
                    } }, void 0), _jsx("div", { className: 'indicator1-spinner-bounce2', style: {
                        backgroundColor: backgroundColor,
                        color: color,
                        fill: color,
                        height: getIndicatorSizeValue(props.size),
                        width: getIndicatorSizeValue(props.size)
                    } }, void 0), _jsx("div", { className: 'indicator1-spinner-bounce3', style: {
                        backgroundColor: backgroundColor,
                        color: color,
                        fill: color,
                        height: getIndicatorSizeValue(props.size),
                        width: getIndicatorSizeValue(props.size)
                    } }, void 0)] }, void 0) }, void 0));
};
