import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { useTheme } from '@mui/material/styles';
import { Box } from '@mui/material';
import { SizeEnumeration } from './../../shared/styleProps';
export const Indicator2 = (props) => {
    // External hooks
    const themeStyles = useTheme();
    const getIndicatorSizeValue = (size) => {
        var sizeValue = 64;
        switch (size) {
            case SizeEnumeration.xs:
                sizeValue = 16;
                break;
            case SizeEnumeration.s:
                sizeValue = 24;
                break;
            case SizeEnumeration.m:
                sizeValue = 32;
                break;
            case SizeEnumeration.l:
                sizeValue = 64;
                break;
            case SizeEnumeration.xl:
                sizeValue = 128;
                break;
            default:
                sizeValue = 64;
                break;
        }
        return sizeValue;
    };
    // Helpers
    const backgroundColor = (props.backgroundColor !== undefined) ? props.backgroundColor : themeStyles.palette.secondary.main;
    const color = (props.color !== undefined) ? props.color : themeStyles.palette.secondary.contrastText;
    return (_jsx(Box, { sx: {
            height: '100%',
            display: 'flex',
            flexDirection: 'column',
            justifyContent: 'center',
            justifyItems: 'center',
            alignContent: 'center',
            alignItems: 'center'
        }, children: _jsxs(Box, { sx: {
                position: 'relative',
                margin: 'auto',
                height: getIndicatorSizeValue(props.size),
                width: getIndicatorSizeValue(props.size)
            }, children: [_jsx("div", { className: 'indicator2-spinner-double-bounce1', style: {
                        backgroundColor: backgroundColor,
                        color: color,
                        fill: color
                    } }, void 0), _jsx("div", { className: 'indicator2-spinner-double-bounce2', style: {
                        backgroundColor: backgroundColor,
                        color: color,
                        fill: color
                    } }, void 0)] }, void 0) }, void 0));
};
