import React from 'react';
import { LocalizeMethod, BrudererUserRoleEnumeration } from '@brudererdev/web-extensions';
import { INavigationElement, ViewProps, ActionTileProps, IActionTileContextProps, ISelectable, IActionTileNavigationElement } from '../..';
interface ILocalProps {
    showHeader?: boolean;
    contextName?: string;
    navigationElements: Array<INavigationElement>;
    defaultNavigationElement: INavigationElement;
    preselectedNavigationElement?: INavigationElement;
    showActionTilesByDefault?: boolean;
    userRoles?: Array<BrudererUserRoleEnumeration>;
    locale?: string;
    onImportView: (selectedElement: INavigationElement) => React.LazyExoticComponent<React.ComponentType<ViewProps>>;
    onImportActionTile?: (fileName: string) => React.LazyExoticComponent<React.ComponentType<ActionTileProps>>;
    onLoadActionTiles?: () => Array<IActionTileContextProps>;
    onLoadNavigationElements?: () => Array<IActionTileNavigationElement>;
    onLocalize?: LocalizeMethod;
    onInvokeAction?: (elementKey: string, payload?: any) => boolean;
    onInvokeDialog?: (elementKey: string, payload?: any) => boolean;
    onShowApps?: (e: React.MouseEvent<HTMLElement>) => void;
    onClose?: (e: React.MouseEvent<HTMLElement>) => void;
    onSelect?: (e: React.MouseEvent<HTMLElement>, element: ISelectable, index: number) => boolean;
    onAssistantClick?: () => void;
    onStatusClick?: () => void;
    onMessageAcknowledge?: () => void;
}
declare type Props = ILocalProps;
export declare const SubViewInjector: React.FC<Props>;
export {};
