import { jsx as _jsx } from "react/jsx-runtime";
import { useMemo, Suspense } from 'react';
import { View } from './../View';
import { SizeEnumeration } from './../../shared/styleProps';
import { ErrorBoundary } from './../ErrorBoundary';
import { ErrorContent } from './../ErrorContent';
import { Indicator1 } from './../indicators/Indicator1';
export const ViewInjector = (props) => {
    const getPreselectedViewElement = (element) => {
        if (!props.navigationRequest)
            return undefined;
        if (!element.elements)
            return undefined;
        return element.elements.find((element, index) => element.key === props.navigationRequest.preselectKey);
    };
    // Lazy import of the selected view component
    const GenericView = useMemo(() => {
        return props.onImportView(props.navigationElement);
    }, [props.navigationElement.key]);
    return (_jsx(ErrorBoundary, { sourceName: props.navigationElement.fileName, fallback: (source, error, errorInfo) => {
            return (_jsx(View, { children: _jsx(ErrorContent, { sourceName: source, errorMessage: error && error.toString(), stackInfo: errorInfo.componentStack }, void 0) }, void 0));
        }, children: _jsx(Suspense, { fallback: _jsx(View, { contentStyle: {
                    height: '100%',
                    width: '100%',
                    display: 'flex',
                    flexDirection: 'column',
                    alignItems: 'center',
                    alignContent: 'center',
                    justifyItems: 'center',
                    justifyContent: 'center'
                }, children: _jsx(Indicator1, { size: SizeEnumeration.l }, void 0) }, void 0), children: _jsx(GenericView, { elements: props.navigationElement.elements, preselectedElement: getPreselectedViewElement(props.navigationElement), onClose: props.onClose }, void 0) }, void 0) }, void 0));
};
