import React from 'react';
import { Theme } from '@mui/material/styles';
import { SxProps } from '@mui/system';
import { IMessage } from '@brudererdev/web-extensions';
export declare enum AssistantContextEnumeration {
    Unknown = 0,
    Default = 1,
    BackendConnectionError = 2,
    PLCConnectionError = 3,
    InfoMessagePending = 4,
    NoLoadedToolAvailable = 5,
    ErrorMessagePending = 6
}
export interface IMessageAssistantContext {
    message: IMessage;
}
export interface IAssistantContext {
    contextType: AssistantContextEnumeration;
    style?: SxProps<Theme>;
    context?: IMessageAssistantContext;
}
interface ILocalProps {
    type?: 'MessageBar' | 'ActionTile';
    onClick?: (context: IAssistantContext) => void;
    onAssistantContextChanged?: (context: IAssistantContext) => void;
}
declare type Props = ILocalProps;
export declare const AssistantRendererComponent: React.FC<Props>;
export declare const AssistantRenderer: React.NamedExoticComponent<ILocalProps>;
export {};
