import React from "react";
import { Theme } from '@mui/material/styles';
import { SxProps } from '@mui/system';
import { IMessage } from "@brudererdev/web-extensions";
export declare enum StatusContextEnumeration {
    Unknown = 0,
    Message = 1,
    Clutch = 2
}
export interface IMessageStatusContext {
    message: IMessage;
}
export interface IClutchStatusContext {
    isEngaged: boolean;
}
export interface IStatusContext {
    contextType: StatusContextEnumeration;
    style?: SxProps<Theme>;
    context?: IMessageStatusContext | IClutchStatusContext;
}
interface ILocalProps {
    type?: 'MessageBar' | 'ActionTile';
    onStatusContextChanged?: (context: IStatusContext) => void;
}
export declare const StatusRenderer: React.NamedExoticComponent<ILocalProps>;
export {};
