import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { Box, Tab, Tabs, } from '@mui/material';
import { scrollVerticalStyle } from './../../styles/themeExtensions';
;
;
export const TabsRenderer = (props) => {
    const handleTabsChange = (event, newValue) => {
        if (props.onTabSelected) {
            props.onTabSelected(newValue);
        }
        ;
    };
    const renderTabs = (tabs) => {
        if (!tabs)
            return null;
        return tabs.map((tab, tabIndex) => {
            var label = tab.label ? tab.label : tabIndex;
            var value = tab.value ? tab.value : tabIndex;
            return (_jsx(Tab, { sx: [
                    (theme) => ({
                        '&.MuiTab-root': {
                            minHeight: minTabHeight,
                            height: '100%',
                            minWidth: orientation === 'vertical' ? minTabWidth : 160,
                            width: orientation === 'vertical' ? minTabWidth : 160,
                            display: 'flex',
                            flexDirection: 'row',
                            textTransform: 'none',
                            borderStyle: 'solid',
                            padding: 0,
                            opacity: 1,
                            borderColor: theme.palette.background.default,
                            backgroundColor: theme.palette.card.main,
                            color: theme.palette.card.contrastText,
                            fill: theme.palette.card.contrastText,
                            marginBottom: orientation === 'horizontal' ? theme.spacing(1) : undefined,
                            marginRight: orientation === 'vertical' ? theme.spacing(1) : undefined,
                            marginInline: orientation === 'horizontal' ? '1px' : undefined,
                            marginBlock: orientation === 'vertical' ? '1px' : undefined,
                            borderWidth: orientation === 'horizontal' ? '0px 0px 1px 0px' : '0px 1px 0px 0px',
                        },
                    }),
                    (theme) => ({
                        '&.MuiTab-root': {
                            ...tab.tabStyle
                        }
                    })
                ], label: _jsx(Box, { sx: {
                        height: 80,
                        width: '100%',
                        display: 'flex',
                        justifyItems: 'center',
                        justifyContent: 'center',
                        alignItems: 'center',
                        alignContent: 'center'
                    }, children: label }, void 0), icon: tab.icon, value: value }, tabIndex));
        });
    };
    const renderContent = (tabs) => {
        var tab = tabs.find(tab => tab.value === selectedTabValue);
        if (!tab || !tab.content)
            return null;
        return (_jsx(Box, { sx: {
                height: '100%',
                width: '100%',
                ...scrollVerticalStyle
            }, children: tab.content }, void 0));
    };
    // Helpers
    const orientation = props.orientation ? props.orientation : 'horizontal';
    const variant = props.variant ? props.variant : 'fullWidth';
    const tabs = props.tabs;
    const topLeftCornerEmpty = props.topLeftCornerEmpty ? props.topLeftCornerEmpty : false;
    const selectedTabValue = (props.selectedTab !== undefined) ? props.selectedTab : false;
    const minTabHeight = (props.minTabHeight !== undefined) ? props.minTabHeight : 80;
    const minTabWidth = (props.minTabWidth !== undefined) ? props.minTabWidth : 240;
    if (!tabs)
        return null;
    return (_jsxs(Box, { sx: {
            width: '100%',
            height: '100%',
            display: 'flex',
            flexDirection: orientation === 'horizontal' ? 'column' : 'row'
        }, children: [_jsxs(Box, { sx: {
                    width: orientation === 'horizontal' ? '100%' : undefined,
                    lineHeight: orientation === 'vertical' ? '100%' : undefined,
                    display: 'flex',
                    flexDirection: orientation === 'horizontal' ? 'row' : 'column',
                    marginBottom: orientation === 'horizontal' ? (theme) => theme.spacing(1) : undefined,
                    marginRight: orientation === 'vertical' ? (theme) => theme.spacing(1) : undefined
                }, children: [topLeftCornerEmpty &&
                        _jsx(Box, { sx: {
                                height: minTabHeight,
                                minWidth: minTabWidth + 8,
                                width: minTabWidth + 8,
                                borderStyle: 'solid',
                                borderWidth: '0px 0px 1px 0px',
                                borderColor: (theme) => theme.palette.card.contrastText,
                            } }, void 0), _jsx(Tabs, { sx: [
                            (theme) => ({
                                '&.MuiTabs-root': {
                                    height: orientation === 'horizontal' ? minTabHeight : '100%',
                                    width: orientation === 'horizontal' ? '100%' : minTabWidth,
                                    borderStyle: 'solid',
                                    borderColor: theme.palette.card.contrastText,
                                    borderWidth: orientation === 'horizontal' ? '0px 0px 1px 0px' : '0px 1px 0px 0px'
                                },
                                '& .MuiTabs-indicator': {
                                    width: orientation === 'vertical' ? 8 : undefined,
                                    height: orientation === 'horizontal' ? 8 : undefined,
                                    backgroundColor: theme.palette.secondary.main,
                                    opacity: 1
                                }
                            }),
                            (theme) => ({
                                '&.MuiTabs-root': {
                                    ...props.tabStyle
                                }
                            })
                        ], scrollButtons: 'auto', orientation: orientation, variant: variant, value: selectedTabValue, centered: (variant === 'scrollable') ? false : true, onChange: handleTabsChange, children: renderTabs(props.tabs) }, void 0)] }, void 0), renderContent(tabs)] }, void 0));
};
