export const getNumericKeyboardLayout = (language) => {
    return defaultNumericLayout;
};
export const getAlphaNumericKeyboardLayout = (language) => {
    return defaultAlphaNumericLayout;
};
export const defaultNumericLayout = [
    [
        {
            keys: [
                { value: '7' },
                { value: '8' },
                { value: '9' }
            ]
        },
        {
            keys: [
                { value: '4' },
                { value: '5' },
                { value: '6' }
            ]
        },
        {
            keys: [
                { value: '1' },
                { value: '2' },
                { value: '3' }
            ]
        },
        {
            keys: [
                { value: '0', growSize: 2 },
                { value: '.' }
            ]
        },
    ],
    [
        {
            keys: [
                { value: '{bksp}', sign: '←', signSize: 32, width: 100 }
            ]
        },
        {
            keys: [
                { value: '{invsign}', sign: '+/-', signSize: 32, width: 100 }
            ]
        },
        {
            keys: [
                { value: '{enter}', sign: '↵', signSize: 40, width: 100 }
            ], growSize: 2
        },
    ]
];
export const defaultAlphaNumericLayout = [
    [
        {
            keys: [
                { value: '1', valueShift: '+' },
                { value: '2', valueShift: '"' },
                { value: '3', valueShift: '*' },
                { value: '4', valueShift: 'ç' },
                { value: '5', valueShift: '%' },
                { value: '6', valueShift: '&' },
                { value: '7', valueShift: '/' },
                { value: '8', valueShift: '(' },
                { value: '9', valueShift: ')' },
                { value: '0', valueShift: '=' }
            ]
        },
        {
            keys: [
                { value: 'q', valueShift: 'Q' },
                { value: 'w', valueShift: 'W' },
                { value: 'e', valueShift: 'E' },
                { value: 'r', valueShift: 'R' },
                { value: 't', valueShift: 'T' },
                { value: 'z', valueShift: 'Z' },
                { value: 'u', valueShift: 'U' },
                { value: 'i', valueShift: 'I' },
                { value: 'o', valueShift: 'O' },
                { value: 'p', valueShift: 'P' },
                { value: 'ü', valueShift: 'Ü' }
            ]
        },
        {
            keys: [
                { value: 'a', valueShift: 'A' },
                { value: 's', valueShift: 'S' },
                { value: 'd', valueShift: 'D' },
                { value: 'f', valueShift: 'F' },
                { value: 'g', valueShift: 'G' },
                { value: 'h', valueShift: 'H' },
                { value: 'j', valueShift: 'J' },
                { value: 'k', valueShift: 'K' },
                { value: 'l', valueShift: 'L' },
                { value: 'ö', valueShift: 'Ö' },
                { value: 'ä', valueShift: 'Ä' }
            ]
        },
        {
            keys: [
                { value: '{shift}', sign: '↑' },
                { value: 'y', valueShift: 'Y' },
                { value: 'x', valueShift: 'X' },
                { value: 'c', valueShift: 'C' },
                { value: 'v', valueShift: 'V' },
                { value: 'b', valueShift: 'B' },
                { value: 'n', valueShift: 'N' },
                { value: 'm', valueShift: 'M' },
                { value: '.', valueShift: ',' },
                { value: ':', valueShift: ';' },
                { value: '-', valueShift: '_' }
            ]
        },
        {
            keys: [
                { value: '{space}', sign: '', growSize: 7 }
            ]
        },
    ],
    [
        {
            keys: [
                { value: '{bksp}', sign: '←', signSize: 42, width: 100 }
            ]
        },
        {
            keys: [
                { value: '{enter}', sign: '↵', signSize: 42, width: 100 }
            ], growSize: 4
        },
    ]
];
