import { NotificationTypeEnumeration } from '@brudererdev/web-extensions';
import CheckCircleIcon from '@mui/icons-material/CheckCircle';
import ErrorIcon from '@mui/icons-material/Error';
import InfoIcon from '@mui/icons-material/Info';
import WarningIcon from '@mui/icons-material/Warning';
export const getNotificationIcon = (notification) => {
    switch (notification.notificationType) {
        case NotificationTypeEnumeration.Fault:
            return ErrorIcon;
        case NotificationTypeEnumeration.Information:
            return InfoIcon;
        case NotificationTypeEnumeration.Success:
            return CheckCircleIcon;
        case NotificationTypeEnumeration.Warning:
            return WarningIcon;
        case NotificationTypeEnumeration.Unknown:
            return InfoIcon;
        default:
            return InfoIcon;
    }
    ;
};
export const getNotificationStyle = (notification) => {
    switch (notification.notificationType) {
        case NotificationTypeEnumeration.Fault:
            return {
                backgroundColor: (theme) => theme.palette.error.main,
                color: (theme) => theme.palette.error.contrastText,
                fill: (theme) => theme.palette.error.contrastText
            };
        case NotificationTypeEnumeration.Information:
            return {
                backgroundColor: (theme) => theme.palette.info.main,
                color: (theme) => theme.palette.info.contrastText,
                fill: (theme) => theme.palette.info.contrastText
            };
        case NotificationTypeEnumeration.Success:
            return {
                backgroundColor: (theme) => theme.palette.success.main,
                color: (theme) => theme.palette.success.contrastText,
                fill: (theme) => theme.palette.success.contrastText
            };
        case NotificationTypeEnumeration.Warning:
            return {
                backgroundColor: (theme) => theme.palette.warning.main,
                color: (theme) => theme.palette.warning.contrastText,
                fill: (theme) => theme.palette.warning.contrastText
            };
        case NotificationTypeEnumeration.Unknown:
            return {
                backgroundColor: (theme) => theme.palette.primary.main,
                color: (theme) => theme.palette.primary.contrastText,
                fill: (theme) => theme.palette.primary.contrastText
            };
        default:
            return {
                backgroundColor: (theme) => theme.palette.primary.main,
                color: (theme) => theme.palette.primary.contrastText,
                fill: (theme) => theme.palette.primary.contrastText
            };
    }
    ;
};
