/// <reference types="react" />
import { Theme } from '@mui/material/styles';
import { SxProps } from '@mui/system';
import { LocalizeMethod } from '@brudererdev/web-extensions';
import { SizeEnumeration } from './styleProps';
import { ISelectable } from './selectionProps';
import { IActionTileNavigationElement } from '..';
export declare const defaultTileSize: number;
export declare const defaultActionTileWidth: number;
export declare const defaultActionTileHeight: number;
export interface ITileBaseProps {
    tileStyle?: SxProps<Theme>;
    flashingStyle?: SxProps<Theme>;
    minWidth?: number | string;
    width?: number | string;
    minHeight?: number | string;
    height?: number | string;
    isDisabled?: boolean;
    isFlashing?: boolean;
    flashingInterval?: number;
    onClick?: (e: React.MouseEvent<HTMLButtonElement, MouseEvent>) => void;
    onMouseDown?: (e: React.MouseEvent<HTMLButtonElement, MouseEvent>) => void;
    onMouseUp?: (e: React.MouseEvent<HTMLButtonElement, MouseEvent>) => void;
    onTouchStart?: (e: any) => void;
    onTouchEnd?: (e: any) => void;
}
export interface ITileBadgeProps {
    badgeStyle?: SxProps<Theme>;
    isBadgeVisible?: boolean;
    badgeContent?: string | number;
    badgeSize?: SizeEnumeration;
    badgeOrientation?: 'left' | 'right';
    badgeTopOffset?: number;
    badgeLeftOffset?: number;
}
export interface IActionTileContextProps {
    fileName: string;
    contentStyle?: SxProps<Theme>;
    labelStyle?: SxProps<Theme>;
}
export interface IActionTileProps {
    contentStyle?: SxProps<Theme>;
    labelStyle?: SxProps<Theme>;
    labelButtonStyle?: SxProps<Theme>;
    labelButtonIcon?: React.FunctionComponent<any> | React.ComponentType<any> | string;
    minWidth?: number | string;
    width?: number | string;
    minHeight?: number | string;
    height?: number | string;
    isScrollLocked?: boolean;
    elements?: Array<IActionTileNavigationElement>;
    selectedElementIndex?: number;
    preSelectedContentIndex?: number;
    preSelectedLayerindex?: number;
    numberOfLayers?: number;
    numberOfContents?: number;
    onLocalize?: LocalizeMethod;
    onHeaderClick?: (e: React.MouseEvent<HTMLElement, MouseEvent>) => void;
    onContentClick?: (e: React.MouseEvent<HTMLElement, MouseEvent>) => void;
    onLabelButtonClick?: (e: React.MouseEvent<HTMLElement, MouseEvent>) => void;
    onElementSelect?: (e: React.MouseEvent<HTMLElement>, element: ISelectable, index: number) => void;
    onRenderContent?: (layerIndex: number, contentIndex: number) => React.ReactElement | null;
    onRenderHeader?: () => React.ReactNode;
    onRenderFooter?: () => React.ReactNode;
    onLoadActionTile?: (fileName: string) => void;
}
export interface IActionTileMenuItem {
}
export declare type TileBaseProps = ITileBaseProps;
export declare type TileProps = TileBaseProps & ITileBadgeProps;
export declare type ActionTileProps = IActionTileProps;
export interface IGenericTileLayout {
    name: string;
    props: TileProps;
}
