import { FilterTypeEnumeration } from '@brudererdev/web-extensions';
;
;
;
;
;
;
;
;
;
;
export const getFilteredVariables = (sourceVariables, filters, onLocalize, filledByStart) => {
    if (filters.length <= 0)
        return sourceVariables;
    var filterFilledByStart = (filledByStart !== undefined) ? filledByStart : true;
    var filteredVariables = filterFilledByStart ? sourceVariables : [];
    var variablesPerFilterText = [];
    // Iterate trough all filters
    for (var filter of filters) {
        if (filter.filterText === undefined)
            continue;
        var filterTexts = [];
        if (Array.isArray(filter.filterText))
            filterTexts = filter.filterText;
        else
            filterTexts.push(filter.filterText);
        variablesPerFilterText = [];
        // Iterate trough all filter texts
        for (var filterText of filterTexts) {
            const canFilter = filter.minimumFilterLength === undefined || (filter.minimumFilterLength !== undefined && (filterText.length >= filter.minimumFilterLength));
            if (!canFilter) {
                variablesPerFilterText = filteredVariables;
                continue;
            }
            const filterByLocalization = filter.filterByLocalization !== undefined ? filter.filterByLocalization : true;
            const filterByLinkKey = filter.filterByLinkKey !== undefined ? filter.filterByLinkKey : false;
            const variableFilter = filter.filterType !== undefined ? filter.filterType : FilterTypeEnumeration.Includes;
            if (filteredVariables.length <= 0)
                filteredVariables = sourceVariables;
            var foundVariables = filteredVariables.filter((variable, index) => {
                var filterResult = false;
                if (filterByLocalization) {
                    var localizedDisplayValue = (onLocalize !== undefined) ? onLocalize(variable.display) : variable.display.value;
                    switch (variableFilter) {
                        case FilterTypeEnumeration.Includes:
                            filterResult = localizedDisplayValue.toLowerCase().includes(filterText.toLowerCase());
                            break;
                        case FilterTypeEnumeration.Excludes:
                            filterResult = !localizedDisplayValue.toLowerCase().includes(filterText.toLowerCase());
                            break;
                        case FilterTypeEnumeration.Equals:
                            filterResult = localizedDisplayValue.toLowerCase() === filterText.toLowerCase();
                            break;
                        case FilterTypeEnumeration.StartsWith:
                            filterResult = localizedDisplayValue.toLowerCase().startsWith(filterText.toLowerCase());
                            break;
                        case FilterTypeEnumeration.EndsWith:
                            filterResult = localizedDisplayValue.toLowerCase().endsWith(filterText.toLowerCase());
                            break;
                        default:
                            filterResult = localizedDisplayValue.toLowerCase().includes(filterText.toLowerCase());
                            break;
                    }
                }
                ;
                if (!filterResult && filterByLinkKey) {
                    switch (variableFilter) {
                        case FilterTypeEnumeration.Includes:
                            filterResult = variable.modelLink.key.toLowerCase().includes(filterText.toLowerCase());
                            break;
                        case FilterTypeEnumeration.Excludes:
                            filterResult = !variable.modelLink.key.toLowerCase().includes(filterText.toLowerCase());
                            break;
                        case FilterTypeEnumeration.Equals:
                            filterResult = variable.modelLink.key.toLowerCase() === filterText.toLowerCase();
                            break;
                        case FilterTypeEnumeration.StartsWith:
                            filterResult = variable.modelLink.key.toLowerCase().startsWith(filterText.toLowerCase());
                            break;
                        case FilterTypeEnumeration.EndsWith:
                            filterResult = variable.modelLink.key.toLowerCase().endsWith(filterText.toLowerCase());
                            break;
                        default:
                            filterResult = variable.modelLink.key.toLowerCase().includes(filterText.toLowerCase());
                            break;
                    }
                }
                ;
                return filterResult;
            });
            if (variableFilter === FilterTypeEnumeration.Excludes) {
                filteredVariables = foundVariables;
                variablesPerFilterText = foundVariables;
            }
            else {
                variablesPerFilterText.push(...foundVariables);
            }
        }
        filteredVariables = variablesPerFilterText;
    }
    return filteredVariables;
};
