;
;
export const scrollVerticalStyle = {
    overflowX: 'hidden',
    overflowY: 'auto',
    scrollbarWidth: 'thin',
    scrollbarColor: (theme) => theme.palette.primary.main,
    '&::-webkit-scrollbar': {
        width: '0.4rem'
    },
    '&::-webkit-scrollbar-thumb': {
        backgroundColor: (theme) => theme.palette.primary.main
    }
};
export const scrollHorizontalStyle = {
    overflowX: 'auto',
    overflowY: 'hidden',
    scrollbarWidth: 'thin',
    scrollbarColor: (theme) => theme.palette.primary.main,
    '&::-webkit-scrollbar': {
        width: '0.4rem'
    },
    '&::-webkit-scrollbar-thumb': {
        backgroundColor: (theme) => theme.palette.primary.main
    }
};
export const textBreakWordStyle = {
    overflow: 'hidden',
    overflowWrap: 'break-word',
    whiteSpace: 'pre-wrap',
    wordBreak: 'break-word'
};
export const horizontalLineStyle = {
    width: '100%',
    border: 'none',
    borderTop: '1px solid',
    opacity: 0.6,
    margin: 0
};
export const cardStyle = {
    width: '100%',
    borderRadius: 0
};
export const cardContentStyle = {
    width: '100%',
    height: '100%',
    overflow: 'hidden',
    backgroundColor: (theme) => theme.palette.card.main,
    color: (theme) => theme.palette.card.contrastText,
    fill: (theme) => theme.palette.card.contrastText
};
export const cardMediaStyle = {
    width: '100%',
    height: '100%',
    overflow: 'hidden',
    backgroundColor: (theme) => theme.palette.card.main,
    color: (theme) => theme.palette.card.contrastText,
    fill: (theme) => theme.palette.card.contrastText
};
export const accordionSummaryRootStyle = {
    padding: 0,
    margin: 0,
    backgroundColor: (theme) => theme.palette.card.main,
    color: (theme) => theme.palette.card.contrastText,
    fill: (theme) => theme.palette.card.contrastText
};
export const accordionSummaryExpandedStyle = {
    backgroundColor: (theme) => theme.palette.primary.main,
    color: (theme) => theme.palette.primary.contrastText,
    fill: (theme) => theme.palette.primary.contrastText
};
export const accordionSummaryContentStyle = {
    height: '100%',
    width: '100%'
};
export const accordionDetailsRootStyle = {
    display: 'flex',
    flexDirection: 'column',
    backgroundColor: (theme) => theme.palette.container.main,
    color: (theme) => theme.palette.container.contrastText,
    fill: (theme) => theme.palette.container.contrastText,
    // borderLeftStyle: 'solid',
    // borderLeftWidth: 2,
    // borderLeftColor: theme.palette.primary.main,
    borderBottomStyle: 'solid',
    borderBottomWidth: 2,
    borderBottomColor: (theme) => theme.palette.primary.main,
    // borderRightStyle: 'solid',
    // borderRightWidth: 2,
    // borderRightColor: theme.palette.primary.main
};
export const dialogPaperStyle = {
    backgroundColor: (theme) => theme.palette.view.main,
    color: (theme) => theme.palette.view.contrastText,
    fill: (theme) => theme.palette.view.contrastText,
};
export const dialogTitleStyle = {
    backgroundColor: (theme) => theme.palette.primary.main,
    color: (theme) => theme.palette.primary.contrastText,
    fill: (theme) => theme.palette.primary.contrastText
};
export const dialogTitleContainerStyle = {
    display: 'flex',
    flexDirection: 'row',
    alignContent: 'center',
    alignItems: 'center',
    margin: (theme) => theme.spacing(1)
};
export const dialogContainerStyle = {
    flex: 'auto',
    display: 'flex',
    flexDirection: 'column',
    overflow: 'hidden',
    margin: (theme) => theme.spacing(1)
};
export const tileIconStyle = {
    minWidth: 48,
    minHeight: 48,
    width: 48,
    height: 48
};
export const tileIconStyleCSS = {
    minWidth: 48,
    minHeight: 48,
    width: 48,
    height: 48
};
export const itemIconStyle = {
    minWidth: 40,
    minHeight: 40,
    width: 40,
    height: 40
};
export const itemIconStyleCSS = {
    minWidth: 40,
    minHeight: 40,
    width: 40,
    height: 40
};
export const textWhiteSpaceStyle = {
    whiteSpace: 'pre',
    ':before': {
        content: '" "'
    },
    ':after': {
        content: '" "'
    }
};
